javax.servlet

## Interface ReadListener

- All Superinterfaces:
    java.util.EventListener

      public interface ReadListener
      extends java.util.EventListener

  Receives notification of read events when using non-blocking IO.
  Since:
    Servlet 3.1

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `onAllDataRead()` Invoked when the request body has been fully read.
    `void` | `onDataAvailable()` Invoked when data is available to read.
    `void` | `onError(java.lang.Throwable throwable)` Invoked if an error occurs while reading the request body.

- - ### Method Detail

    - #### onDataAvailable

          void onDataAvailable()
                        throws java.io.IOException

      Invoked when data is available to read. The container will invoke this method the first time for a request as soon as there is data to read. Subsequent invocations will only occur if a call to `ServletInputStream.isReady()` has returned false and data has subsequently become available to read.
      Throws:
        `java.io.IOException` - id an I/O error occurs while processing the event

    - #### onAllDataRead

          void onAllDataRead()
                      throws java.io.IOException

      Invoked when the request body has been fully read.
      Throws:
        `java.io.IOException` - id an I/O error occurs while processing the event

    - #### onError

          void onError(java.lang.Throwable throwable)

      Invoked if an error occurs while reading the request body.
      Parameters:
        `throwable` - The exception that occurred

Copyright © 2000-2022 Apache Software Foundation. All Rights Reserved.